# std::deque<T,Allocator>::at

From cppreference.com
< cpp‎ | container‎ | deque

reference at( size_type pos ); | (1) |
const_reference at( size_type pos ) const; | (2) |

Returns a reference to the element at specified location pos, with bounds checking.

If pos is not within the range of the container, an exception of type std::out_of_range is thrown.

### Parameters

pos | - | position of the element to return

### Return value

Reference to the requested element

### Exceptions

std::out_of_range if pos >= size().

### Complexity

Constant.

### Example

Run this code

    #include <chrono>
    #include <cstddef>
    #include <iostream>
    #include <deque>
    #include <stdexcept>

    int main()
    {
        std::deque<int> data{1, 2, 4, 5, 5, 6};

        // Set element 1
        data.at(1) = 88;

        // Read element 2
        std::cout << "Element at index 2 has value " << data.at(2) << '\n';

        std::cout << "data size = " << data.size() << '\n';

        try
        {
            // Try to set an element at random position >= size()
            auto moon_phase = []
            {
                return std::chrono::system_clock::now().time_since_epoch().count() % 8;
            };
            data.at(data.size() + moon_phase()) = 13;
        }
        catch(const std::out_of_range& ex)
        {
            std::cout << ex.what() << '\n';
        }

        // Print final values
        std::cout << "data:";
        for (int elem : data)
            std::cout << ' ' << elem;
        std::cout << '\n';
    }

Possible output:

    Element at index 2 has value 4
    data size = 6
    deque::_M_range_check: __n (which is 8) >= this->size() (which is 6)
    data: 1 88 4 5 5 6

### See also

operator[] | access specified element (public member function)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/container/deque/at&oldid=135170"